define PVWLEQRT  (nrep = !charend('/')
                   /stat = !charend('/')
                   /pv = !charend('/') 
                   /WLE = !charend('/') 
                   /grp = !charend('/') 
                   /wgt = !charend('/') 
                   /rwgt = !charend('/')
                   /cons = !charend('/')
                   /infile = !charend('/')).

get file=!infile /keep=!grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !concat(pv,1,!pv) 
  !concat(pv,2,!pv) !concat(pv,3,!pv) !concat(pv,4,!pv) !concat(pv,5,!pv) !wle.


select if not missing (!wle).
means !wle /cell=mean min max.

* COMPUTE CUMULATIVE COUNT WITHIN COUNTRIES.
*----------------------------------------------.
sort cases by cnt.
autorecode cnt /into cnt# /print.

!do !s=1 !to 5.
set seed = !s.
!let !v=!concat(!wle,!s).
!let !c=!concat('cumfreq',!s).

compute !v=!wle+rv.normal(0,.0001).
sort cases by cnt# !v.

do if ($casenum=1 or lag(cnt#) <> cnt#).
compute !c=w_fstuwt. 
else if (cnt#=lag(cnt#)).
compute !c=w_fstuwt + lag(!c). 
end if.
sort cases by cnt.
!doend.
save outfile='C:\temp\temp.sav'.

* DEFINE CUTSCORES.
*----------------------------------------------.
weight by w_fstuwt.
aggregate outfile=*  /break=cnt  /total=max(cumfreq1).
compute cut25=total/(100/25).
compute cut50=total/(100/50).
compute cut75=total/(100/75).

match files file='C:\temp\temp.sav'
  /table=*
  /by cnt.
exe.

* CREATE PERCENTILE GROUPS.
*--------------------------------------.
do repeat c=cumfreq1 cumfreq2 cumfreq3 cumfreq4 cumfreq5 /q=quart1 quart2 quart3 quart4 quart5.
if (c<cut25) q=1.
if (c>=cut25 & c<cut50) q=2.
if (c>=cut50 & c<cut75) q=3.
if (c>=cut75) q=4.
formats q (f1.0).
end repeat.
save outfile='C:\temp\quarters.sav'.



*** COMPUTE STATISTIC ***.
!do !j=1 !to 5.
get file='C:\temp\quarters.sav' /keep !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !concat(pv,1,!pv) 
  !concat(pv,2,!pv) !concat(pv,3,!pv) !concat(pv,4,!pv) !concat(pv,5,!pv) quart1 quart2 quart3 quart4 quart5.
weight by !wgt.
rename var (!concat('quart',!j)=quart).
erase file=!quote(!concat('C:\temp\temp',!j,'.sav')).
aggregate outfile = !quote(!concat('C:\temp\temp',!j,'.sav')) /break=!grp quart
   /!concat('stat',!j)=!stat(!concat('pv',!j,!pv)).
!doend.    
    
match files file='C:\temp\temp1.sav'
           /file='C:\temp\temp2.sav'
           /file='C:\temp\temp3.sav'
           /file='C:\temp\temp4.sav'
           /file='C:\temp\temp5.sav'
           /by !grp quart.
erase file='C:\temp\all.sav'.
save outfile='C:\temp\all.sav'.

* REPLICATES.

!do !i= 1 !to !nrep.
!do !j=1 !to 5.
get file='C:\temp\quarters.sav' /keep !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !concat(pv,1,!pv) 
  !concat(pv,2,!pv) !concat(pv,3,!pv) !concat(pv,4,!pv) !concat(pv,5,!pv) quart1 quart2 quart3 quart4 quart5.
weight by !concat(!rwgt,!i).
rename var (!concat('quart',!j)=quart).
sort cases by !grp quart.
erase file=!quote(!concat('C:\temp\temp',!j,'.sav')).
aggregate outfile = !quote(!concat('C:\temp\temp',!j,'.sav')) /break=!grp quart
   /!concat('statR',!j)=!stat(!concat('pv',!j,!pv)).
!doend.    
    
match files file='C:\temp\temp1.sav'
           /file='C:\temp\temp2.sav'
           /file='C:\temp\temp3.sav'
           /file='C:\temp\temp4.sav'
           /file='C:\temp\temp5.sav'
           /by !grp quart.
erase file=!quote(!concat('C:\temp\',!pv,!i,'.sav')).
save outfile = !quote(!concat('C:\temp\',!pv,!i,'.sav')).

!doend.

*** COMBINE RESULTS ***.

get file =!quote(!concat('C:\temp\',!pv,'1','.sav')).
cache.

!Do !e = 2 !to !nrep.
add files/file=*/file=!quote(!concat('C:\temp\',!pv,!e,'.sav')).
!Doend.

sort cases by !grp quart.

match files file=*/table= 'C:\temp\all.sav'/by !grp quart.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr1 to statr5/
	  b=stat1 to stat5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.
save outfile = 'C:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!grp quart/ 
          stat1 to stat5= mean(stat1 to stat5)/
          var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).




*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat1 to stat5).

do repeat a=stat1 to stat5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.

compute pvmerr=.25*(sum(pvar1 to pvar5)).




*** COMPUTE STANDARD ERROR [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp quart stat SE.

!enddefine.
