define PV  (nrep = !charend('/')/
            stat = !charend('/')/
            dep = !charend('/') /
            grp = !charend('/') /
            wgt = !charend('/') /
            rwgt = !charend('/') /
            cons = !charend('/')/
            infile = !charend('/')).



get file !infile /keep !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !concat(pv,1,!dep) 
  !concat(pv,2,!dep) !concat(pv,3,!dep) !concat(pv,4,!dep) !concat(pv,5,!dep) .



*** COMPUTE STATISTIC ***.

weight by !wgt.
erase file='c:\temp\all.sav'.
aggregate outfile = 'c:\temp\all.sav' /break=!grp /
    stat1 stat2 stat3 stat4 stat5=!stat(!concat(pv1,!dep) !concat(pv2,!dep) !concat(pv3,!dep) !concat(pv4,!dep) !concat(pv5,!dep)).


* REPLICATES.

!do !i= 1 !to !nrep.
weight by !concat(!rwgt,!i).
erase file=!quote(!concat('c:\temp\',!dep,!i,'.sav')).
aggregate outfile = !quote(!concat('c:\temp\',!dep,!i,'.sav'))/break=!grp /
    statr1 statr2 statr3 statr4 statr5=!stat(!concat(pv1,!dep) !concat(pv2,!dep) !concat(pv3,!dep) !concat(pv4,!dep) !concat(pv5,!dep)).
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('c:\temp\',!dep,'1','.sav')).
cache.

!Do !e = 2 !to !nrep.
add files/file=*/file=!quote(!concat('c:\temp\',!dep,!e,'.sav')).
!Doend.

sort cases by !grp.

match files file=*/table= 'c:\temp\all.sav'/by !grp.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr1 to statr5/
	  b=stat1 to stat5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!grp/ 
          stat1 to stat5= mean(stat1 to stat5)/
          var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).




*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat1 to stat5).

do repeat a=stat1 to stat5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.

compute pvmerr=.25*(sum(pvar1 to pvar5)).




*** COMPUTE STANDARD ERROR [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp stat SE.

!enddefine.
